package ru.dbotthepony.kstarbound.client.render

import ru.dbotthepony.kstarbound.client.ClientChunk
import ru.dbotthepony.kstarbound.client.gl.GLStateTracker
import ru.dbotthepony.kstarbound.math.Matrix4fStack
import ru.dbotthepony.kstarbound.math.Vector2d
import ru.dbotthepony.kstarbound.world.entities.Entity
import java.io.Closeable

/**
 * Базовый класс, отвечающий за отрисовку определённого ентити в мире
 *
 * Считается, что процесс отрисовки ограничен лишь одним слоем (т.е. отрисовка происходит в один проход)
 */
open class EntityRenderer(val state: GLStateTracker, val entity: Entity, open var chunk: ClientChunk?) : Closeable {
	open val renderPos: Vector2d get() = entity.pos

	open fun render(stack: Matrix4fStack) {

	}

	open fun renderDebug() {
		if (chunk?.world?.client?.settings?.debugCollisions == true) {
			state.quadWireframe(entity.worldaabb)
		}
	}

	open val layer: Int = 100

	override fun close() {

	}
}
